#include <WiFi.h>
#include <WebServer.h>
#define PWM_R_F 18 
#define PWM_L_F 19 
#define PWM_R_B 22 
#define PWM_L_B 23 
#define IN_R_F_1 13 
#define IN_R_F_2 12 
#define IN_R_B_1 14 
#define IN_R_B_2 27 
#define IN_L_F_1 26 
#define IN_L_F_2 35 
#define IN_L_B_1 33 
#define IN_L_B_2 32 
#define SERVO_UP_D 2
#define SERVO_T 4
/*    SSID   */
const char* ssid = "ESP32";  
const char* password = "01234567";  
/*  IP  */
IPAddress local_ip(192,168,2,1);
IPAddress gateway(192,168,2,1);
IPAddress subnet(255,255,255,0);
WebServer server(80);
bool L = LOW;
bool R = LOW;
uint8_t speed = 0; 
uint8_t LED1pin = 4;
bool LED1status = LOW;
uint8_t LED2pin = 5;
bool LED2status = LOW;
void setup() {
  Serial.begin(115200);
  pinMode(PWM_L_B, OUTPUT);
  pinMode(PWM_L_F, OUTPUT);
  pinMode(PWM_R_B, OUTPUT);
  pinMode(PWM_R_F, OUTPUT);
  pinMode(IN_L_B_1, OUTPUT);
  pinMode(IN_L_B_2, OUTPUT);
  pinMode(IN_L_F_1, OUTPUT);
  pinMode(IN_L_F_2, OUTPUT);
  pinMode(IN_R_B_1, OUTPUT);
  pinMode(IN_R_B_2, OUTPUT);
  pinMode(IN_R_F_1, OUTPUT);
  pinMode(IN_R_F_2, OUTPUT);
  pinMode(SERVO_T, OUTPUT);
  pinMode(SERVO_UP_D, OUTPUT);
  WiFi.softAP(ssid, password);
  WiFi.softAPConfig(local_ip, gateway, subnet);
  delay(100);
  server.on("/", handle_OnConnect);
  server.on("/fw", forward);
  server.on("/turn_l", turn_left);
  server.on("/turn_r", turn_right);
  server.on("/bak", back);
  server.on("/st", stop);
  //server.on("/up_d", );
  //server.on("/take", );
  server.onNotFound(handle_NotFound);
  server.begin();
  Serial.println("HTTP server started");
}
void loop() {
  server.handleClient();

}
void handle_OnConnect() {
  Serial.println("Start");
  server.send(200, "text/html", SendHTML(false, false,false, false,false, false)); 
}
void handle_NotFound(){
  server.send(404, "text/plain", "Not found");
}
void forward(){
  analogWrite(PWM_R_F, 255);
  analogWrite(PWM_L_F, 255);
  analogWrite(PWM_R_B, 255);
  analogWrite(PWM_L_B, 255);
  digitalWrite(IN_R_F_1, 1);
  digitalWrite(IN_R_F_2, 0);
  digitalWrite(IN_L_F_1, 1);
  digitalWrite(IN_L_F_2, 0);
  digitalWrite(IN_R_B_1, 1);
  digitalWrite(IN_R_B_2, 0);
  digitalWrite(IN_L_B_1, 1);
  digitalWrite(IN_L_B_2, 0);
  Serial.println("run forward");
  server.send(200, "text/html", SendHTML(true, false,false, false,false, false)); 
}
void back(){
  analogWrite(PWM_R_F, 255);
  analogWrite(PWM_L_F, 255);
  analogWrite(PWM_R_B, 255);
  analogWrite(PWM_L_B, 255);
  digitalWrite(IN_R_F_1, 0);
  digitalWrite(IN_R_F_2, 1);
  digitalWrite(IN_L_F_1, 0);
  digitalWrite(IN_L_F_2, 1);
  digitalWrite(IN_R_B_1, 0);
  digitalWrite(IN_R_B_2, 1);
  digitalWrite(IN_L_B_1, 0);
  digitalWrite(IN_L_B_2, 1);
  Serial.println("run to backword");
  server.send(200, "text/html", SendHTML(false, true,false, false,false, false)); 

}
void turn_left(){
  analogWrite(PWM_R_F, 250);
  analogWrite(PWM_L_F, 250);
  analogWrite(PWM_R_B, 250);
  analogWrite(PWM_L_B, 250);
  digitalWrite(IN_R_F_1, 1);
  digitalWrite(IN_R_F_2, 0);
  digitalWrite(IN_L_F_1, 0);
  digitalWrite(IN_L_F_2, 1);
  digitalWrite(IN_R_B_1, 1);
  digitalWrite(IN_R_B_2, 0);
  digitalWrite(IN_L_B_1, 0);
  digitalWrite(IN_L_B_2, 1);
  Serial.println("na levo");
  server.send(200, "text/html", SendHTML(false, false,false, true,false, false)); 
}
void turn_right(){
  analogWrite(PWM_R_F, 250);
  analogWrite(PWM_L_F, 250);
  analogWrite(PWM_R_B, 250);
  analogWrite(PWM_L_B, 250);
  digitalWrite(IN_R_F_1, 0);
  digitalWrite(IN_R_F_2, 1);
  digitalWrite(IN_L_F_1, 1);
  digitalWrite(IN_L_F_2, 0);
  digitalWrite(IN_R_B_1, 0);
  digitalWrite(IN_R_B_2, 1);
  digitalWrite(IN_L_B_1, 1);
  digitalWrite(IN_L_B_2, 0);
  Serial.println("na pravo");
  server.send(200, "text/html", SendHTML(false, false, true, false,false, false)); 
}
void stop(){
  analogWrite(PWM_R_F, 250);
  analogWrite(PWM_L_F, 250);
  analogWrite(PWM_R_B, 250);
  analogWrite(PWM_L_B, 250);
  digitalWrite(IN_R_F_1, 0);
  digitalWrite(IN_R_F_2, 0);
  digitalWrite(IN_L_F_1, 0);
  digitalWrite(IN_L_F_2, 0);
  digitalWrite(IN_R_B_1, 0);
  digitalWrite(IN_R_B_2, 0);
  digitalWrite(IN_L_B_1, 0);
  digitalWrite(IN_L_B_2, 0);
  Serial.println("STOP");
  server.send(200, "text/html", SendHTML(false, false,false, false,false, false)); 
}


/*
void up_grip(){

}
void take(){

}
*/
String SendHTML(uint8_t f,uint8_t b,uint8_t tr,uint8_t tl,uint8_t t,uint8_t u ){
  String ptr = "<!DOCTYPE html> <html>\n";
  ptr +="<meta http-equiv=\"Content-type\" content=\"text/html; charset=utf-8\"><head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0, user-scalable=no\">\n";
  ptr +="<title>   </title>\n";
  ptr +="<style>html { font-family: Helvetica; margin: 0px auto; text-align: center;}\n";
  ptr +="body{margin-top: 50px;} h1 {color: #444444;margin: 50px auto 30px;} h3 {color: #444444;margin-bottom: 50px;}\n";
  ptr +=".button {display:flex;width: 80px;background-color: #3498db;border:none;color: white;padding: 13px 30px;text-decoration: none;font-size: 25px;margin: 0px auto 35px;cursor: pointer;border-radius: 4px;\n";
  ptr +=".button-on {background-color: #3498db;}\n";
  ptr +=".button-on:active {background-color: #2980b9;}\n";
  ptr +=".button-off {background-color: #34495e;}\n";
  ptr +=".button-off:active {background-color: #2c3e50;}\n";
  ptr +="p {font-size: 14px;color: #888;margin-bottom: 10px;}\n";
  ptr +="</style>\n";
  ptr +="</head>\n";
  ptr +="<body>\n";
  ptr +="<h1>  </h1>\n";
  if(f)
  {ptr += "<a class=\"button button-off\" href=\"/st\">.</a>\n";}
  else
  {ptr +="<a class=\"button button-on\" href=\"/fw\">.</a>\n";}
  if(tl)
  {ptr +="<div align=left><a class=\"button button-off\" href=\"/st\">.</a></div>\n";}
  else
  {ptr +="<div align=left><a class=\"button button-on\" href=\"/turn_l\">.</a></div>\n";}
  if(tr)
  {ptr +="<div align=right><a class=\"button button-off\" href=\"/st\">.</a></div>\n";}
  else
  {ptr +="<div align=right><a class=\"button button-on\" href=\"/turn_r\">.</a></div>\n";}
  if(b)
  {ptr +="<a class=\"button button-off\" href=\"/st\">.</a>\n";}
  else
  {ptr +="<a class=\"button button-on\" href=\"/bak\">.</a>\n";}
  /*if(t)
  {ptr +="<a class=\"button button-off\" href=\"/st\">.</a>\n";}
  else
  {ptr +="<a class=\"button button-on\" href=\"/take\">.</a>\n";}
  if(u)
  {ptr +="<a class=\"button button-off\" href=\"/st\">.</a>\n";}
  else
  {ptr +="<a class=\"button button-on\" href=\"/up_d\">.</a>\n";}
  server.on("/", handle_OnConnect);
  server.on("/fw", forward);
  server.on("/turn_l", );
  server.on("/turn_r", turn_right);
  server.on("/bak", back);
  server.on("/st", stop);
  */
  ptr +="</body>\n";
  ptr +="</html>\n";
  return ptr;
}